package de.accso.flexinale.data.services;

import de.accso.flexinale.data.model.Benutzer;
import de.accso.flexinale.data.persistence.AbstractDao;
import de.accso.flexinale.data.persistence.BenutzerDao;
import jakarta.transaction.Transactional;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellType;
import org.apache.poi.ss.usermodel.Row;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
@Transactional
public non-sealed class BenutzerUploadService extends AbstractExcelDataUploadService<Benutzer> {
    private static final Logger LOGGER = LoggerFactory.getLogger(BenutzerUploadService.class);

    @Autowired
    private BenutzerDao benutzerDao;

    @Override
    public AbstractDao<Benutzer> getDao() {
        return benutzerDao;
    }

    @Override
    public String getNameOfExcelDataType() {
        return Benutzer.class.getSimpleName();
    }

    @Override
    public Benutzer createDataFromExcelRow(final Row excelRow) {
        String benutzerId = excelRow.getCell(0).getStringCellValue();

        // set authorization roles
        Cell cellRolle = excelRow.getCell(6);
        Benutzer.Rolle rolle;
        if (cellRolle == null || cellRolle.getCellType() == CellType.BLANK) {
            rolle = null;
        }
        else {
            rolle = Benutzer.Rolle.valueOf(cellRolle.getStringCellValue());
        }

        Benutzer benutzer = new Benutzer(
                benutzerId,
                excelRow.getCell(1).getStringCellValue(),
                excelRow.getCell(3).getStringCellValue(),
                excelRow.getCell(4).getStringCellValue(),
                excelRow.getCell(5).getStringCellValue(),
                rolle
        );

        benutzer.encryptAndSetPassword(excelRow.getCell(2).getStringCellValue());

        LOGGER.debug("New Benutzer created: " + benutzer);

        return benutzer;
    }
}
